#include <LiquidCrystal.h>

// Connections:
// rs (LCD pin 4) to Arduino pin 12
// rw (LCD pin 5) to Arduino pin 11
// enable (LCD pin 6) to Arduino pin 10
// LCD pin 15 to Arduino pin 13
// LCD pins d4, d5, d6, d7 to Arduino pins 5, 4, 3, 2
// all white 730 838 739 830 656
// all black 367 500 223 420 315
// avg value 550 670 481 625 485

LiquidCrystal lcd(12, 11, 10, 5, 4, 3, 2);
char dir='N';
int backLight = 13;    // pin 13 will control the backlight

int s0=550;
int s1=670;
int s2=631;
int s3=625;
int s4=485;

int grid_x=2, grid_y=2;
int cx=0, cy=0;
int a[5];
int sensorValue;
void setup()
{
  Serial.begin(9600);
  pinMode(backLight, OUTPUT);
  pinMode(0, OUTPUT);
  pinMode(1, OUTPUT);
  pinMode(6, OUTPUT);
  pinMode(7, OUTPUT);
  digitalWrite(backLight, HIGH); // turn backlight on. Replace 'HIGH' with 'LOW' to turn it off.
  lcd.begin(16,2);              // columns, rows.  use 16,2 for a 16x2 LCD, etc.
  lcd.clear();    
  lcd.setCursor(0,0);           // set cursor to column 0, row 0 (the first row)
  lcd.print(sensorValue);   // start with a blank screen
     // change this text to whatever you like. keep it clean.
  //lcd.setCursor(0,1);           // set cursor to column 0, row 1
  //lcd.print("");
  
  // if you have a 4 row LCD, uncomment these lines to write to the bottom rows
  // and change the lcd.begin() statement above.
  //lcd.setCursor(0,2);         // set cursor to column 0, row 2
  //lcd.print("Row 3");
  //lcd.setCursor(0,3);         // set cursor to column 0, row 3
  //lcd.print("Row 4");
}

int ReadSensor(uint8_t sensor, int x, int y)
{
  sensorValue = analogRead(sensor);
  lcd.setCursor(x,y);
  lcd.print(sensorValue); 
  Serial.println(sensorValue);
  return sensorValue;
}
void forward()
{
  digitalWrite(0, LOW); //Right
  digitalWrite(1, HIGH); //Right
  digitalWrite(6, LOW); //Left
  digitalWrite(7, HIGH); //Left
}
void turn_left()
{
  digitalWrite(0, LOW);
  digitalWrite(1, HIGH);
  digitalWrite(6, LOW);
  digitalWrite(7, LOW);
}
void turn_right()
{
  digitalWrite(0, LOW);
  digitalWrite(1, LOW);
  digitalWrite(6, LOW);
  digitalWrite(7, HIGH);
}

void right_90()
{
  digitalWrite(0, HIGH);
  digitalWrite(1, LOW);
  digitalWrite(6, LOW);
  digitalWrite(7, HIGH);
}  
void left_90()
{
  digitalWrite(0, LOW);
  digitalWrite(1, HIGH);
  digitalWrite(6, HIGH);
  digitalWrite(7, LOW);
}  
void stopp()
{
  digitalWrite(0, LOW);
  digitalWrite(1, LOW);
  digitalWrite(6, LOW);
  digitalWrite(7, LOW);
}

void uturn()
{
  grid_right();
  right_90();
  delay(2000);
  while(ReadSensor(A0, 0, 1)>=s0)
  right_90();
  if(dir=='N')
  dir='E';
  else if(dir=='E')
  dir='S';
  else if(dir=='S')
  dir='W';
  else if(dir=='W')
  dir='N';
} 
void line_follow()
{
  int left = ReadSensor(A1, 0, 0);
  int middle = ReadSensor(A2, 4, 0);
  int right = ReadSensor(A3, 8, 0);
  int exleft = ReadSensor(A0, 0, 1);
  int exright = ReadSensor(A4, 4, 1);
if(middle < s2 && left >s1 && right >s3)
{
  lcd.setCursor(13,0);
  lcd.print("For");
  forward();
}
else if(left < s1 && right > s3 && middle > s2)
{
  lcd.setCursor(13,0);
  lcd.print("Lef");
  turn_left();
}
else if(right < s3 && middle > s2 && left > s1)
{
  lcd.setCursor(13,0);
  lcd.print("Rig");
  turn_right();
}
else if(exleft < s0)
{
  lcd.setCursor(13,0);
  lcd.print("ELe");
  turn_left();
}
else if(exright < s4)
{
  lcd.setCursor(13,0);
  lcd.print("ELe");
  turn_right();
}
}
//int count = 0;

void grid_right()
{
  forward();
  delay(1000);
  right_90();
  delay(2000);
  while(ReadSensor(A0, 0, 1)>=s0)
  right_90();
  if(dir=='N')
  dir='E';
  else if(dir=='E')
  dir='S';
  else if(dir=='S')
  dir='W';
  else if(dir=='W')
  dir='N';
  
 
}
void grid_left()
{
  forward();
  delay(1000);
  left_90();
  delay(2000);
  while(ReadSensor(A4, 0, 1)>=s4)
  left_90();
  if(dir=='N')
  dir='W';
   else if(dir=='E')
  dir='N';
  else if(dir=='S')
  dir='E';
  else if(dir=='W')
  dir='S';
  
 
}


void grid_forward(int count)
{
  int temp=0;
  while(1)
  {
  int exleft = ReadSensor(A0, 0, 1);
  int exright = ReadSensor(A4, 4, 1);
  if(exleft < s0 && exright < s4) //when either of the extreme sensors are off the line
    { 
       stopp();
       delay(1000);
       temp++;
       
       lcd.setCursor(8,1);
  lcd.print(temp);
  if(temp==count)
  {
     stopp();
     return;
  }
else
{
  forward();
  delay(1000);
}  
    }
  line_follow();
  }
}

void move_robot(int dx, int dy)
{
  if(dx-cx>0 && dy-cy==0)
  {
    if(dir=='N')
    {
      grid_right();
      grid_forward(dx-cx);
       }
    else if(dir=='E')
    {
      grid_forward(dx-cx);
    }
    else if(dir=='S')
    {
      grid_left();
      grid_forward(dx-cx);
    }
    else if(dir=='W')
    {
      uturn();
      grid_forward(dx-cx);
    }
    cx+=dx-cx;;  
    lcd.setCursor(10,1);
    lcd.print(dir);
   lcd.setCursor(12,1);
    lcd.print(cx); 
lcd.setCursor(14,1);
    lcd.print(cy); 
 
  }
  
      
  if(dx-cx==0 && dy-cy>0)
  {
    
    if(dir=='N')
    {
      grid_forward(dy-cy);
    }
    else if(dir=='E')
    {
      grid_left();
      grid_forward(dy-cy);
    }
    else if(dir=='W')
    {
      grid_right();
      grid_forward(dy-cy);
    }
    else if(dir=='S')
    {
      uturn();
      grid_forward(dy-cy);
    }
    cy+=dy-cy;
lcd.setCursor(10,1);
    lcd.print(dir); 
lcd.setCursor(12,1);
    lcd.print(cx); 
lcd.setCursor(14,1);
    lcd.print(cy); 
 
  }
  if(dx-cx<0 && dy-cy==0)
  {
    
    if(dir=='N')
    {
      grid_left();
      grid_forward(cx-dx);
       }
    else if(dir=='S')
    {
      grid_right();
      grid_forward(cx-dx);
    }
    else if(dir=='W')
    {
      grid_forward(cx-dx);
    }
    else if(dir=='E')
    {
      uturn();
      grid_forward(cx-dx);
    }
    cx-=cx-dx;
    lcd.setCursor(10,1);
    lcd.print(dir); 
lcd.setCursor(12,1);
    lcd.print(cx); 
lcd.setCursor(14,1);
    lcd.print(cy); 
 
  }
  if(dx-cx==0 && dy-cy<0)
  {
    
    if(dir=='W')
    {
      grid_left();
      grid_forward(cy-dy);
       }
    else if(dir=='E')
    {
      grid_right();
      grid_forward(cy-dy);
    }
    else if(dir=='S')
    {
      grid_forward(cy-dy);
    }
    else if(dir=='N')
    {
      uturn();
      grid_forward(cy-dy);
    }
   cy-=cy-dy;
  lcd.setCursor(10,1);
    lcd.print(dir); 
 lcd.setCursor(12,1);
    lcd.print(cx); 
lcd.setCursor(14,1);
    lcd.print(cy); 
 
  }
}

void move_general(int gx, int gy)
{
  move_robot(gx, cy);
  move_robot(gx,gy);
  return;
}
void loop()
{
  forward();
  /*
  ReadSensor(A0, 0, 0);
  ReadSensor(A1, 4, 0 );
  ReadSensor(A2, 8, 0);
  ReadSensor(A3, 12, 0);
  ReadSensor(A4, 0, 1);
  */
  //lcd.setCursor(10,1);
  //lcd.print(dir); 
// move_general(3,3);
 //move_general(2,4);
  move_general(4,0);
 // move_robot(3,2);
 //uturn();
 //grid_forward(1);
//  lcd.setCursor(10,1);
  //lcd.print(dir); 
  //lcd.setCursor(0,0);
  //lcd.print("~~~ROBOTIX~~~~~");
 //lcd.setCursor(0,1);
  //lcd.print("~~~~~~2013~~~~~~"); 
 

}
